/*****************************************************************************/
/* ChildFrm.h : interface of the CChildFrame class                           */
/*****************************************************************************/

#if !defined(AFX_CHILDFRM_H__9052BAFB_9D44_11D5_8163_4000001054B2__INCLUDED_)
#define AFX_CHILDFRM_H__9052BAFB_9D44_11D5_8163_4000001054B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"

/*****************************************************************************/
/* CChildFrame class declaration                                             */
/*****************************************************************************/

class CEffectWnd;
class CChildFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CChildFrame)
    friend class CEffectWnd;            /* these are allowed to call         */
    friend class CEffEditWnd;           /* OnEffEdit.../OnUpdateEffEdit...   */
public:
	CChildFrame();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	void ResizeToContent();
	void OnSetProgram();
	void EditClosed();
	void ParmClosed();
    int  GetEffect() { return nEffect; }
	void SetEffect(int nEffect);
	int nEffect;
	void SetNewTitle(LPCSTR lpszText);
	// view for the client area of the frame.
	CChildView m_wndView;
	virtual ~CChildFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	void SetupTitle();
	CString sTitle;
	void SaveBank(CString sName);
	int nCanEdit;
	HMENU m_hEditMenu;
	void ShowDetails();
	CEffectWnd * pEditWnd;
	CEffectWnd * pParmWnd;
	//{{AFX_MSG(CChildFrame)
	afx_msg void OnFileClose();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnEffEdit();
	afx_msg void OnClose();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnUpdateEffEdit(CCmdUI* pCmdUI);
	afx_msg void OnEffEditParms();
	afx_msg void OnEffLoad();
	afx_msg void OnEffSave();
	afx_msg void OnEffSaveas();
	afx_msg void OnEffSelprogram();
	afx_msg void OnUpdateEffSelprogram(CCmdUI* pCmdUI);
	afx_msg void OnSelMidichn();
	//}}AFX_MSG
    afx_msg void OnSetProgram(UINT nID);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDFRM_H__9052BAFB_9D44_11D5_8163_4000001054B2__INCLUDED_)
