/*****************************************************************************/
/* EffectWnd.h : header file                                                 */
/*****************************************************************************/

#if !defined(AFX_EFFECTWND_H__E21437F5_9BA1_11D5_8161_4000001054B2__INCLUDED_)
#define AFX_EFFECTWND_H__E21437F5_9BA1_11D5_8161_4000001054B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*****************************************************************************/
/* CEffectWnd window                                                         */
/*****************************************************************************/

class CChildFrame;
class CEffectWnd : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CEffectWnd)
// Construction
public:
	CEffectWnd();

// Attributes
public:

// Operations
public:
    virtual void SetEffect(int nEff) { nEffect = nEff; }
    int  GetEffect() { return nEffect; }
    void SetMain(CChildFrame *pFrm) { pMain = pFrm; }
    void SetupTitle();
    virtual HICON RetrieveIcon() { return AfxGetApp()->LoadIcon(IDI_EFFEDIT); }
    virtual LPCSTR GetEditType() { return "E"; }
    virtual BOOL NeedView() { return FALSE; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEffectWnd)
	public:
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual void Update();
    virtual bool OnSetParameterAutomated(long index, float value) { return false; }
	void SetEffSize(int cx, int cy);
	void SetEffSize(ERect *pRect);
	virtual ~CEffectWnd();

	// Generated message map functions
protected:
	void MakeVstKeyCode(UINT nChar, UINT nRepCnt, UINT nFlags, VstKeyCode &keyCode);
	BOOL GetEffectEditWndSize(CRect &rcFrame, CRect &rcClient, ERect *pRect = NULL);
    virtual CWnd * CreateView() { return NULL; }
	CRect rcEffFrame;
	CRect rcEffClient;
	CWnd * pView;
	CChildFrame * pMain;
	CVSTHost * pHost;
	int nEffect;
	//{{AFX_MSG(CEffectWnd)
	afx_msg void OnClose();
	afx_msg void OnEffProgramName();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnEffEditParms();
	afx_msg void OnEffEdit();
	afx_msg void OnUpdateEffEdit(CCmdUI* pCmdUI);
	afx_msg void OnEffInfo();
	afx_msg void OnEffResize();
	afx_msg void OnEffChecksize();
	afx_msg void OnEffLoad();
	afx_msg void OnEffSave();
	afx_msg void OnEffSaveas();
	afx_msg void OnEffSelprogram();
	afx_msg void OnUpdateEffSelprogram(CCmdUI* pCmdUI);
	afx_msg void OnSelMidichn();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
    afx_msg void OnSetProgram(UINT nID);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EFFECTWND_H__E21437F5_9BA1_11D5_8161_4000001054B2__INCLUDED_)
